<?php
/*
Plugin Name: Quick Chat
Plugin URI: http://www.techytalk.info/quick-chat
Description: Quick Chat is quick and elegant WordPress chat plugin. Quick Chat supports chat rooms, in-post embedding, custom bad words filtering, emoticons, translation and css customization.
Author: Marko Martinović
Version: 1.84
Author URI: http://www.techytalk.info
License: GPL2

Copyright 2011.  Marko Martinović  (email : marko AT techytalk.info)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License, version 2, as
published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

global $default_quick_chat_db_version;
global $default_badwords_list;
global $default_tld_blocklist;
global $default_disallow_usernames_list;
global $default_name;
global $default_keep_around_count;
global $default_name;
global $default_guest_num_digits;

global $quick_chat_options;
global $quick_chat_widget_options; 
global $quick_chat_db_version;
global $quick_chat_url;
global $quick_chat_path;
global $quick_chat_is_embedded;
global $quick_chat_audio_enable;
global $quick_chat_smile_array;
global $quick_chat_chat_data_array;
global $quick_chat_last_timestamp;
global $quick_chat_user_ip;
global $quick_chat_user_status;

global $quick_chat_date_format;
global $quick_chat_time_format;
global $quick_chat_gmt_offset;

$default_badwords_list = '4r5e, 5h1t, 5hit, a55, anal, ar5e, arrse, arse, ass, ass-fucker, assfucker, assfukka, asshole, asswhole, b!tch, b00bs, b17ch, b1tch, ballbag, balls, ballsack, bastard, beastiality, bi+ch, bitch, bloody, blowjob, boiolas, boobs, booobs, boooobs, booooobs, booooooobs, breasts, buceta, bunny fucker, buttmuch, c0ck, c0cksucker, cawk, chink, cipa, cl1t, clit, clit, clits, cnut, cock, cock-sucker, cockface, cockhead, cockmunch, cockmuncher, cocksucker, cocksuka, cocksukka, cok, cokmuncher, coksucka, cox, cum, cunt, cyalis, d1ck, dick, dickhead, dildo, dirsa, dlck, dog-fucker, doggin, dogging, donkeyribber, doosh, duche, ejakulate, f u c k e r, f4nny, fag, faggitt, faggot, fanny, fannyflaps, fannyfucker, fanyy, fatass, fcuk, fcuker, fcuking, feck, fecker, fook, fooker, fuck, fuck, fucka, fucker, fuckhead, fuckin, fucking, fuckingshitmotherfucker, fuckwhit, fuckwit, fuk, fuker, fukker, fukkin, fukwhit, fukwit, fux, fux0r, gaylord, goatse, heshe, hoare, hoer, hore, jackoff, jism, kawk, knob, knobead, knobed, knobhead, knobjocky, knobjokey, l3i+ch, l3itch, m0f0, m0fo, m45terbate, ma5terb8, ma5terbate, master-bate, masterb8, masterbat, masterbat3, masterbation, masterbations, masturbate, mo-fo, mof0, mofo, motherfucker, motherfuckka, mutha, muthafecker, muthafuckker, muther, mutherfucker, n1gga, n1gger, nazi, nigg3r, nigg4h, nigga, niggah, niggas, niggaz, nigger, nob, nob jokey, nobhead, nobjocky, nobjokey, numbnuts, nutsack, p0rn, pawn, penis, penisfucker, phuck, pigfucker, pimpis, piss, pissflaps, porn, prick, pron, pusse, pussi, pussy, rimjaw, rimming, s.o.b., schlong, scroat, scrote, scrotum, sh!+, sh!t, sh1t, shag, shagger, shaggin, shagging, shemale, shi+, shit, shit, shitdick, shite, shited, shitey, shitfuck, shithead, shitter, slut, smut, snatch, spac, t1tt1e5, t1tties, teets, teez, testical, testicle, titfuck, tits, titt, tittie5, tittiefucker, titties, tittyfuck, tittywank, titwank, tw4t, twat, twathead, twatty, twunt, twunter, v14gra, v1gra, viagra, w00se, wang, wank, wanker, wanky, whoar, whore, willies, willy, vagina';
$default_tld_blocklist = '';
$default_ip_blocklist = '';
$default_disallow_usernames_list = 'admin, moderator';
$default_name = __('Guest_','quick-chat');
$default_keep_around_count = '0';
$default_guest_num_digits = '3';
$default_quick_chat_db_version = '11';

$quick_chat_date_format = get_option('date_format');
$quick_chat_time_format = get_option('time_format');
$quick_chat_gmt_offset = get_option('gmt_offset');
$quick_chat_options = get_option('quick_chat_options');
$quick_chat_widget_options = get_option('widget_quick-chat-widget');
$quick_chat_db_version = get_option('quick_chat_db_version');
$quick_chat_url = WP_PLUGIN_URL.'/'.str_replace(basename( __FILE__),"",plugin_basename(__FILE__));
$quick_chat_path = WP_PLUGIN_DIR.'/'.str_replace(basename( __FILE__),"",plugin_basename(__FILE__));
$quick_chat_chat_data_array = array();
$quick_chat_is_embedded = false;
$quick_chat_user_ip = (isset($_SERVER['HTTP_X_FORWARD_FOR'])) ? $_SERVER['HTTP_X_FORWARD_FOR'] : $_SERVER['REMOTE_ADDR'];

if (isset($_COOKIE['quick_chat_sound_state'])){
    $quick_chat_audio_enable = $_COOKIE['quick_chat_sound_state'];
}else{
    $quick_chat_audio_enable = (isset($quick_chat_options['message_sound_default_on'])) ? 1 : 0;
}

function quick_chat_init(){
    global $wpdb;
    global $quick_chat_user_status;
    
    if(current_user_can('manage_options')){
        $quick_chat_user_status = 0;
    }else if(is_user_logged_in()){
        $quick_chat_user_status = 1;
    } else{
        $quick_chat_user_status = 2;
    }
    
    $plugin_path = dirname(plugin_basename(__FILE__));
    load_plugin_textdomain( 'quick-chat', false, $plugin_path.'/languages/' );    
}
add_action('init','quick_chat_init');

// Enqueue stylesheet files
function quick_chat_load_stylesheet() {
    global $quick_chat_url;
    global $quick_chat_path;
    
    $my_style_url = $quick_chat_url . 'css/quick-chat.css';
    $my_style_file = $quick_chat_path . 'css/quick-chat.css';
    
    if (file_exists($my_style_file)) {
        wp_register_style('my_style_sheet', $my_style_url);
        wp_enqueue_style('my_style_sheet');
    }
}
add_action('wp_print_styles', 'quick_chat_load_stylesheet');

// Smilies array
$quick_chat_smile_array = array(
               ':)' => 'smile.png',
		':(' => 'sad.png',
		';)' => 'wink.png',
		':P' =>'razz.png',
		':D' =>'grin.png',
		':|' => 'plain.png',
		':O' => 'surprise.png',
		':?' => 'confused.png',
		'8)' => 'glasses.png',
		'8o' => 'eek.png',
		'B)' => 'cool.png',
		':-)' => 'smile-big.png',
		':-(' => 'crying.png',
		':-*' => 'kiss.png',
		'O:-D' => 'angel.png',
		'&gt;:-D' => 'devilish.png',
		':o)' => 'monkey.png',
		':idea:' =>'idea.png',
		':important:' => 'important.png',
		':help:' => 'help.png',
		':error:' => 'error.png',
		':warning:' => 'warning.png',
		':favorite:' => 'favorite.png'
                );

/* Filter bad words and links class */
class Filter_String {
    public $text = '';  // string to check for bad words and bad domains
    public $bad_words = array();  //array of bad words
    public $blocked_tlds = array(); //array of bad domains
    public $replace_inside_bad_words = true;
    public $keep_first_last = false;

    public function filter(){        
        if($this->text != ''){
            if(!empty($this->bad_words)){
                $this->text = $this->do_filter($this->text, $this->bad_words, $this->keep_first_last, $this->replace_inside_bad_words);
            }

            if(!empty($this->blocked_tlds)){
                /* Construct regex from user defined domains */
                /* First regex part */
                $regex = '/\S+\.(?:';
                foreach($this->blocked_tlds as $blocked_tld){
                    if($blocked_tld == end($this->blocked_tlds)){
                        // Last element without "|" at the end
                        $regex .=  trim($blocked_tld);
                    } else {
                        $regex .=  trim($blocked_tld).'|';
                    }
                }
                /* last regex part */
                $regex .= ')/i';

                preg_match_all($regex, $this->text, $urls_found2D,PREG_SET_ORDER);
                
                /* preg_match_all returns 2D array, we need 1D */
                foreach($urls_found2D as $key => $value){
                    foreach($value as $subkey => $subvalue){
                        $urls_found1D[] = $subvalue;
                    }
                }
                if(!empty($urls_found1D))$this->text = $this->do_filter($this->text, $urls_found1D, false, true);                    
            }            
        }
        return $this->text;
    }

    private function do_filter($text, $strings, $keep_first_last, $replace_inside_words){
            foreach($strings as $word){
                /* Strip possible spaces left after csv explode */
                $word = trim($word);

                $replacement = '';

                $str = strlen($word);

                $first = ($keep_first_last) ? $word[0] : '';
                $str = ($keep_first_last) ? $str - 2 : $str;
                $last = ($keep_first_last) ? $word[strlen($word) - 1] : '';

                $replacement = str_repeat('*', $str);

                if($replace_inside_words){

                    if($this->keep_first_last){
                        // Match words with first char lowercase (case sensitive)
                        $text = str_replace($word, $first.$replacement.$last, $text);                        
                        
                        // Match words with first char uppercase (case sensitive)
                        $text = str_replace(ucfirst($word), strtoupper($first).$replacement.$last, $text);
                    } else{
                        // Match words with first char uppercase (case sensitive)
                        $text = str_ireplace($word, $first.$replacement.$last, $text);                          
                    }
                }
                else{
                    if($this->keep_first_last){
                        // Match words with first char lowercase (case sensitive)
                        $text = preg_replace('/\b'.$word.'\b/', $first.$replacement.$last, $text);

                        // Match words with first char uppercase (case sensitive)
                        $text = preg_replace('/\b'.ucfirst($word).'\b/', strtoupper($first).$replacement.$last, $text);
                    } else{
                        // Match words with first char uppercase (case insensitive)
                        $text = preg_replace('/\b'.$word.'\b/i', $first.$replacement.$last, $text);
                    }
                }
            }
        return $text;
    }   
}

// Install function
function quick_chat_install() {
    global $wpdb;
    global $default_badwords_list;
    global $default_tld_blocklist;
    global $default_disallow_usernames_list;
    global $default_quick_chat_db_version;
    global $default_name;
    global $default_keep_around_count;
    global $default_guest_num_digits;
    global $quick_chat_options;
    global $quick_chat_widget_options; 
    global $quick_chat_db_version;   
    global $default_ip_blocklist;
    $quick_chat_messages_table_name = $wpdb->prefix . 'quick_chat';
    
	if($wpdb->get_var('SHOW TABLES LIKE \''.$quick_chat_messages_table_name.'\';') != $quick_chat_messages_table_name) {
       $sql_messages = 'CREATE TABLE '.$quick_chat_messages_table_name.' (
        id BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY,
        room VARCHAR(100) NOT NULL DEFAULT "default",
        timestamp INT(10) NOT NULL,
        alias VARCHAR(100) NOT NULL,
        status TINYINT(1) NOT NULL DEFAULT 2,
        ip VARCHAR(15) NOT NULL,
        message TEXT NOT NULL,
        INDEX (timestamp DESC),
        INDEX ( room ASC)) ENGINE=MyISAM DEFAULT CHARACTER SET utf8, COLLATE utf8_general_ci;';     

        require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
        dbDelta($sql_messages);
        
   } else{
        if($quick_chat_db_version < 4){
            // This is upgrade from v3 database to v4 database, we need to alter table (v1.45)
            $query = $wpdb->query( 'ALTER TABLE '.$quick_chat_messages_table_name.' MODIFY alias VARCHAR(100), MODIFY ip VARCHAR(15);');			
        }

        if ($quick_chat_db_version < 5){
                // This is upgrade from v4 database to v5 database, we need to alter main table because of new rooms field (v1.60)
                $query = $wpdb->query('ALTER TABLE '.$quick_chat_messages_table_name.' ADD COLUMN room VARCHAR(100) NOT NULL DEFAULT "default" AFTER id;');

                // Add index on room for performance
                $query = $wpdb->query('ALTER TABLE '.$quick_chat_messages_table_name.' ADD INDEX room (room ASC);');		

                // Add index on timestamp for performance
                $query = $wpdb->query('ALTER TABLE '.$quick_chat_messages_table_name.' ADD INDEX timestamp (timestamp DESC);');

                $query = $wpdb->query( 'ALTER TABLE '.$quick_chat_messages_table_name.' MODIFY timestamp INT(10) NOT NULL, MODIFY alias VARCHAR(100) NOT NULL, MODIFY ip VARCHAR(15) NOT NULL, MODIFY message TEXT NOT NULL default "";');

                if(isset($quick_chat_widget_options)){
                foreach($quick_chat_widget_options as &$option){
                    if (is_array($option) && !empty($option)){
                            $option['room'] = 'default';
                    }
                }
            }			
        }
        
        if ($quick_chat_db_version < 11){
                // This is upgrade from v10 database to v11 database, we need to alter main table because of new isalias field (v1.84)
                $query = $wpdb->query('ALTER TABLE '.$quick_chat_messages_table_name.' ADD COLUMN status TINYINT(1) NOT NULL DEFAULT 2 AFTER alias;');			
        }        
    }
    
    if($quick_chat_db_version < 3){    
        if(!isset($quick_chat_options['allow_logged_in_choice'])) {
            $quick_chat_options['allow_logged_in_choice'] = '1';        
        }

        if(!isset($quick_chat_options['allow_guests_choice'])) {
            $quick_chat_options['allow_guests_choice'] = '1';        
        }
    }
    
    if($quick_chat_db_version < 7){  
        if(!isset($quick_chat_options['hyperlinks'])) {
            $quick_chat_options['hyperlinks'] = '1';       
        }
    }
    
    if($quick_chat_db_version < 9){
        if(!isset($quick_chat_options['disallow_logged_in_usernames'])) {
            $quick_chat_options['disallow_logged_in_usernames'] = '1';        
        }        
    } 
   
    if(!isset($quick_chat_options['default_name'])) {
        $quick_chat_options['default_name'] = $default_name;        
    }

    if(!isset($quick_chat_options['badwords_list'])) {
        $quick_chat_options['badwords_list'] = $default_badwords_list;        
    }    

    if(!isset($quick_chat_options['tld_blocklist'])) {
        $quick_chat_options['tld_blocklist'] = $default_tld_blocklist;        
    }
    
    if(!isset($quick_chat_options['keep_around_count'])) {
        $quick_chat_options['keep_around_count'] = $default_keep_around_count;        
    }
    
    if(!isset($quick_chat_options['guest_num_digits'])) {
        $quick_chat_options['guest_num_digits'] = $default_guest_num_digits;        
    }
    
    if(!isset($quick_chat_options['max_name_length'])) {
        $quick_chat_options['max_name_length'] = strlen($quick_chat_options['default_name']) + $quick_chat_options['guest_num_digits'];        
    }    
    
    if(!isset($quick_chat_options['ip_blocklist'])) {
        $quick_chat_options['ip_blocklist'] = $default_ip_blocklist;        
    }			
    
    if(!isset($quick_chat_options['disallow_usernames_list'])) {
        $quick_chat_options['disallow_usernames_list'] = $default_disallow_usernames_list;        
    } 
    
    update_option('widget_quick-chat-widget', $quick_chat_widget_options);    
    update_option('quick_chat_db_version', $default_quick_chat_db_version);     
    update_option('quick_chat_options', $quick_chat_options);
}

function quick_chat_update_db_check() {
    global $quick_chat_db_version;
    global $default_quick_chat_db_version;
    
    if ($quick_chat_db_version != $default_quick_chat_db_version) {
        quick_chat_install();
    }
}
add_action('plugins_loaded', 'quick_chat_update_db_check');

function quick_chat_audio_ajax_handler(){
    check_ajax_referer('quick_chat_audio_nonce', 'quick_chat_audio_nonce');
    
    if(isset($_POST['sound_toggle'])){
        setcookie("quick_chat_sound_state",$_POST['sound_toggle'],0,"/");
    }
    
    $response = json_encode(array('quick_chat_audio_nonce'=> wp_create_nonce('quick_chat_audio_nonce')));

    header( "Content-Type: application/json" );
    echo $response;
    exit;
}
add_action( 'wp_ajax_nopriv_quick-chat-ajax-audio', 'quick_chat_audio_ajax_handler' );
add_action( 'wp_ajax_quick-chat-ajax-audio', 'quick_chat_audio_ajax_handler' );

function quick_chat_username_check_ajax_handler(){
    global $quick_chat_options;
    global $quick_chat_user_status;
    global $user_login;
    
    check_ajax_referer('quick_chat_username_check_nonce', 'quick_chat_username_check_nonce');
    
    if(isset($_POST['username_check']) &&  !empty($_POST['username_check'])){        
        $username_exists = 0;
        $username_blocked = 0;
        get_currentuserinfo();
        
        if($quick_chat_user_status != 0 && (strcasecmp($_POST['username_check'], $user_login) != 0)){
            global $wp_version;
            if (version_compare($wp_version, '3.1', '<')){
                require_once(ABSPATH . WPINC . '/registration.php');
            }

            if(isset($quick_chat_options['disallow_logged_in_usernames'])){
                if(username_exists($_POST['username_check']) != null){
                    $username_exists = 1;
                }
            }                      

            if(isset($quick_chat_options['disallow_usernames_list']) && ($quick_chat_options['disallow_usernames_list'] != '') && $quick_chat_user_status != 0){
                $blocked_usernames = explode(',', $quick_chat_options['disallow_usernames_list']);
                foreach ($blocked_usernames as $blocked_username) {
                    if(strcasecmp($_POST['username_check'], trim($blocked_username)) == 0){
                        $username_blocked = 1;
                        break;
                    }
                }        
            }            
        }                                
        $response = json_encode(array('username_exists'=> $username_exists , 'username_blocked'=> $username_blocked, 'quick_chat_username_check_nonce'=> wp_create_nonce('quick_chat_username_check_nonce')));
    } else{
        $response = json_encode(array('username_exists'=> 0 , 'username_blocked'=> 1, 'quick_chat_username_check_nonce'=> wp_create_nonce('quick_chat_username_check_nonce')));
    }
    header( "Content-Type: application/json" );    
    echo $response;
    exit;    
}
add_action( 'wp_ajax_nopriv_quick-chat-ajax-username-check', 'quick_chat_username_check_ajax_handler' );
add_action( 'wp_ajax_quick-chat-ajax-username-check', 'quick_chat_username_check_ajax_handler' );

function quick_chat_delete_ajax_handler(){
    global $wpdb;
    global $quick_chat_options;   
    $quick_chat_messages_table_name = $wpdb->prefix . 'quick_chat';
    
    check_ajax_referer('quick_chat_delete_nonce', 'quick_chat_delete_nonce');
    
    if(isset($_POST['to_delete_ids']) && !empty($_POST['to_delete_ids']) && isset($_POST['to_delete_room_name']) && !empty($_POST['to_delete_room_name'])){
        foreach ($_POST['to_delete_ids'] as $value) {
            $wpdb->get_results('DELETE FROM '.$quick_chat_messages_table_name.' WHERE id ='.$value);
        }
    }
    
    $response = json_encode(array('quick_chat_display_history_container' => quick_chat_display_history_container($_POST['to_delete_room_name']),
        'quick_chat_delete_nonce'=> wp_create_nonce('quick_chat_delete_nonce')));

    header( "Content-Type: application/json" );
    echo $response;        
    exit;    
}
add_action( 'wp_ajax_nopriv_quick-chat-ajax-delete', 'quick_chat_delete_ajax_handler' );
add_action( 'wp_ajax_quick-chat-ajax-delete', 'quick_chat_delete_ajax_handler' );

function quick_chat_new_message_ajax_handler(){
    global $wpdb;
    global $quick_chat_options;
    global $quick_chat_user_status;
    
    $quick_chat_messages_table_name = $wpdb->prefix . 'quick_chat';
    
    check_ajax_referer('quick_chat_new_message_nonce', 'quick_chat_new_message_nonce');
    
    if(isset($_POST['alias']) && isset($_POST['message']) && wp_filter_nohtml_kses(trim($_POST['alias']))!="" && wp_filter_nohtml_kses(trim($_POST['message']))!=""){
        // Message has been sent
        $filter = new Filter_String;

        if(isset($quick_chat_options['badwords_list']) && ($quick_chat_options['badwords_list'] != '')){
            $filter->bad_words = explode(',', $quick_chat_options['badwords_list']);
        }

        if(isset($quick_chat_options['tld_blocklist']) && ($quick_chat_options['tld_blocklist'] != '')) {
            $filter->blocked_tlds = explode(',', $quick_chat_options['tld_blocklist']);
        }
        
        if(isset($quick_chat_options['replace_inside_bad_words'])) {
            $filter->replace_inside_bad_words = true;
        } else{
            $filter->replace_inside_bad_words = false;
        }
        
        if(isset($quick_chat_options['keep_first_last'])) {
            $filter->keep_first_last = true;
        } else{
            $filter->keep_first_last = false;
        }
        
        $filter->text = wp_filter_nohtml_kses($_POST['message']);
        $filteredMessage = $filter->filter();
        
        if(isset($quick_chat_options['hyperlinks'])){
            $filteredMessage = links_add_target(make_clickable($filteredMessage));
        }
        
        $filter->text = wp_filter_nohtml_kses($_POST['alias']);
        $filteredAlias = $filter->filter();
        
        if ($quick_chat_user_status < 2){
            setcookie("quick_chat_loggedin_alias",$_POST['alias'],0,"/");
        }else{
            setcookie("quick_chat_guest_alias",$_POST['alias'],0,"/");
        }
        if ($quick_chat_user_status == 0){
            setcookie("quick_chat_admin_alias",$_POST['alias'],0,"/");
        }else if($quick_chat_user_status == 1){
            setcookie("quick_chat_loggedin_alias",$_POST['alias'],0,"/");
        }else{
            setcookie("quick_chat_guest_alias",$_POST['alias'],0,"/");
        }        
        $rows_affected = $wpdb->insert($quick_chat_messages_table_name, array( 'room' => $_POST['room'], 'timestamp' => time(), 'alias' => $filteredAlias, 'status' => $quick_chat_user_status, 'message' => $filteredMessage, 'ip'=>$_SERVER['REMOTE_ADDR']));
    }
    
    $response = json_encode(array('quick_chat_new_message_nonce'=> wp_create_nonce('quick_chat_new_message_nonce')));

    header( "Content-Type: application/json" );
    echo $response;    
    exit;
}
add_action( 'wp_ajax_nopriv_quick-chat-new-message', 'quick_chat_new_message_ajax_handler' );
add_action( 'wp_ajax_quick-chat-new-message', 'quick_chat_new_message_ajax_handler' );

function quick_chat_update_ajax_handler(){
    global $wpdb;
    global $quick_chat_options;
    global $quick_chat_date_format;
    global $quick_chat_time_format;
    global $quick_chat_gmt_offset;     
    $quick_chat_messages_table_name = $wpdb->prefix . 'quick_chat';
    
    check_ajax_referer('quick_chat_update_nonce', 'quick_chat_update_nonce');
    
    if(isset($_POST['quick_chat_update']) && (int)$_POST['quick_chat_update']!=0){
        $startTime = time();
        while((time()-$startTime)<=20){
            $history = $wpdb->get_results( "SELECT * FROM $quick_chat_messages_table_name WHERE timestamp>".$_POST['quick_chat_update']." ORDER BY timestamp DESC" );
            if($history){
                foreach($history as $v){
                    $v->timestring = date_i18n($quick_chat_date_format.' - '.$quick_chat_time_format, $v->timestamp+($quick_chat_gmt_offset* 3600));
                }
                $response = json_encode(array('success'=> 1,'updates'=>$history,'quick_chat_update_nonce'=> wp_create_nonce('quick_chat_update_nonce')));
                
                header( "Content-Type: application/json" );
                echo $response;                
                exit;
            }else{
                sleep(1);
            }
        }
        $response = json_encode(array('success'=> 0, 'quick_chat_update_nonce'=> wp_create_nonce('quick_chat_update_nonce')));

        header( "Content-Type: application/json" );
        echo $response;         
        exit;
    }    
}
add_action( 'wp_ajax_nopriv_quick-chat-update', 'quick_chat_update_ajax_handler' );
add_action( 'wp_ajax_quick-chat-update', 'quick_chat_update_ajax_handler' );

function quick_chat_js() {
    global $quick_chat_options;
    global $quick_chat_url;
    global $quick_chat_audio_enable;
    global $quick_chat_last_timestamp;
    
    /* jQuery */
    wp_enqueue_script('jquery');

    // Register Javascripts
    wp_enqueue_script('quick-chat-modernizr', ($quick_chat_url."js/modernizr.min.js"), array('jquery'), false, true);

    wp_enqueue_script('quick-chat', ($quick_chat_url."js/quickchat.min.js"), array('jquery','quick-chat-modernizr'), false, true);
    //wp_enqueue_script('quick-chat', ($quick_chat_url."js/quickchat.js"), array('jquery','quick-chat-modernizr'), false, true);
}
add_action('wp_head', 'quick_chat_js', 1);

function quick_chat_localize(){
    global $quick_chat_url;
    global $quick_chat_audio_enable;
    global $quick_chat_user_status;
    
    global $quick_chat_smile_array;
    global $quick_chat_chat_data_array;
    global $quick_chat_last_timestamp;
    global $quick_chat_user_ip;
    
    // Pass PHP variables to the Javascript code.
    if($quick_chat_last_timestamp != null){
        wp_localize_script( 'quick-chat', 'quick_chat_js_vars', array   (
                                                                'quick_chat_url' => $quick_chat_url,
                                                                'quick_chat_audio_enable' => $quick_chat_audio_enable,
                                                                'quick_chat_user_status' => $quick_chat_user_status,
                                                                'quick_chat_user_ip' => $quick_chat_user_ip,
                                                                'quick_chat_delete_what_string' => __('You must select at least one message','quick-chat'),
                                                                'quick_chat_reply_to_string' => __('Reply to','quick-chat'),
                                                                'quick_chat_username_exists_string' => __('Sorry, this user name is already taken','quick-chat'),
                                                                'quick_chat_username_blocked_string' => __('Sorry, this user name is forbidden','quick-chat'),
                                                                'quick_chat_ajaxurl' => admin_url('admin-ajax.php'),
                                                                'quick_chat_audio_nonce' => wp_create_nonce('quick_chat_audio_nonce'),
                                                                'quick_chat_username_check_nonce' => wp_create_nonce('quick_chat_username_check_nonce'),
                                                                'quick_chat_delete_nonce' => wp_create_nonce('quick_chat_delete_nonce'),
                                                                'quick_chat_new_message_nonce' => wp_create_nonce('quick_chat_new_message_nonce'),
                                                                'quick_chat_update_nonce' => wp_create_nonce('quick_chat_update_nonce'),
                                                                'quick_chat_last_timestamp' => $quick_chat_last_timestamp,
                                                                'quick_chat_username_check_wait_string' => __('Please wait, user name check is in progress','quick-chat'),        
                                                                'l10n_print_after' => 'quick_chat_l10n_after = ' . json_encode(array('quick_chat_smile_array' => $quick_chat_smile_array, 'quick_chat_chat_data'=> $quick_chat_chat_data_array)) . ';'
                                                            ));        
    }
}
add_action('wp_print_footer_scripts', 'quick_chat_localize');

// Register our settings. Add the settings section, and settings fields
function quick_chat_init_fn(){
    register_setting('quick_chat_options', 'quick_chat_options', 'quick_chat_options_validate' );
    
    add_settings_section('general_section', __('General options','quick-chat'), 'section_general_fn', __FILE__); 
    add_settings_section('filter_section', __('Filter options','quick-chat'), 'section_filter_fn', __FILE__);
    add_settings_section('security_section', __('Security options','quick-chat'), 'section_security_fn', __FILE__);    
    add_settings_section('appearance_section', __('Appearance options','quick-chat'), 'section_appearance_fn', __FILE__);  
    add_settings_section('donate_section', __('Donate to Quick Chat','quick-chat'), 'section_donate_fn', __FILE__);
    
    add_settings_field('quick_chat_def_name', __('Chat name prefix for guest users:','quick-chat'), 'setting_defname_fn', __FILE__, 'general_section');
    add_settings_field('quick_chat_guest_num_digits', __('Maximum number of digits for random guests chat user name sufix:','quick-chat'), 'setting_guest_num_digits_fn', __FILE__, 'general_section');
    add_settings_field('quick_chat_max_name_length', __('Maximum length of guest chat user name (keep in mind first two options in this section):','quick-chat'), 'setting_max_name_length_fn', __FILE__, 'general_section');
    add_settings_field('quick_chat_keep_around_count', __('Keep number of messages (all rooms combined) automatically around this value (enter "0" to disable):','quick-chat'), 'setting_keep_around_count_fn', __FILE__, 'general_section');
    add_settings_field('quick_chat_message_sound_default_on', __('Incoming message sound notification on by default:','quick-chat'), 'setting_message_sound_default_on_fn', __FILE__, 'general_section');
    
    add_settings_field('quick_chat_hyperlinks', __('Convert URLs to hyperlinks (keep in mind that URLs filter has priority):','quick-chat'), 'setting_hyperlinks_fn', __FILE__, 'filter_section');
    add_settings_field('quick_chat_keep_first_last', __('Keep first and last letter of filtered word:','quick-chat'), 'setting_keep_first_last_fn', __FILE__, 'filter_section');
    add_settings_field('quick_chat_replace_inside_bad_words', __('Filter bad words contained inside other words:','quick-chat'), 'setting_replace_inside_bad_words_fn', __FILE__, 'filter_section');
    add_settings_field('quick_chat_bad_words', __('Bad words list (comma separated):','quick-chat'), 'setting_badwords_fn', __FILE__, 'filter_section');    
    add_settings_field('quick_chat_tld_blocklist', __('Filter URLs to the following domains (comma separated):','quick-chat'), 'setting_tld_blocklist_fn', __FILE__, 'filter_section');
    
    add_settings_field('quick_chat_only_logged_in_users', __('Only logged in users can use chat:','quick-chat'), 'setting_only_logged_in_users_fn', __FILE__, 'security_section');
    add_settings_field('quick_chat_allow_guests_choice', __('Allow guest users to choose their chat user names:','quick-chat'), 'setting_allow_guests_choice_fn', __FILE__, 'security_section');        
    add_settings_field('quick_chat_allow_logged_in_choice', __('Allow logged in users to choose their chat user names:','quick-chat'), 'setting_allow_logged_in_choice_fn', __FILE__, 'security_section');
    add_settings_field('quick_chat_disallow_logged_in_usernames', __('Protect registered users user names from being used by other users:','quick-chat'), 'setting_disallow_logged_in_usernames_fn', __FILE__, 'security_section');
    add_settings_field('quick_chat_disallow_usernames_list', __('Restricted chat user names list (comma separated):','quick-chat'), 'setting_disallow_usernames_list_fn', __FILE__, 'security_section');
    add_settings_field('quick_chat_ip_blocklist', __('Deny chat access to the following IP addresses (comma separated):','quick-chat'), 'setting_ip_blocklist_fn', __FILE__, 'security_section');
    
    add_settings_field('quick_chat_hide_widget_if_embedded', __('Hide Quick Chat sidebar widget on pages where Quick Chat is embeded in post:','quick-chat'), 'setting_hide_widget_if_embedded_fn', __FILE__, 'appearance_section');
    add_settings_field('quick_chat_hide_linkhome', __('Hide "Powered by Quick Chat" link (big thanks for not hiding it):','quick-chat'), 'setting_hide_linkhome_fn', __FILE__, 'appearance_section');
    
    add_settings_field('quick_chat_paypal', __('Donate using PayPal (sincere thank you for your help):','quick-chat'), 'setting_paypal_fn', __FILE__, 'donate_section');
}
add_action('admin_init', 'quick_chat_init_fn' );

// Add sub page to the Settings Menu
function quick_chat_add_page_fn() {
    add_options_page('Quick Chat '.__('options page','quick-chat'), 'Quick Chat ', 'administrator', __FILE__, 'options_page_fn');
}
add_action('admin_menu', 'quick_chat_add_page_fn');

function  section_donate_fn() {
    echo '<p>';
    _e('If you find Quick Chat useful you can donate to help its develompent:','quick-chat');
    echo '</p>';
}

function  section_general_fn() {
    echo '<p>';
    _e('Here you can control all general options:','quick-chat');
    echo '</p>';
}

function  section_filter_fn() {
    echo '<p>';
    _e('Here you can control Quick Chat message and chat user names filter:','quick-chat');
    echo '</p>';
}

function  section_security_fn() {
    echo '<p>';
    _e('In this section you can control security options:','quick-chat');
    echo '</p>';
}

function  section_appearance_fn() {
    echo '<p>';
    _e('Here are the Quick Chat appearance options:','quick-chat');
    echo '</p>';
}

function setting_paypal_fn() {
    global $quick_chat_url;
    echo '<a href="https://www.paypal.com/cgi-bin/webscr?cmd=_donations&business=donate%40techytalk%2einfo&lc=US&item_name=Quick%20Chat%20development%20support&no_note=0&currency_code=USD" target="_blank"><img src="'.$quick_chat_url.'img/paypal.gif" /></a>';
}

function setting_defname_fn() {
    global $quick_chat_options;
    echo '<input id="quick_chat_def_name" name="quick_chat_options[default_name]" size="14" type="text" value="'.__($quick_chat_options['default_name'],'quick-chat').'" />';
}

function setting_keep_around_count_fn() {
    global $quick_chat_options;
    echo '<input id="quick_chat_keep_around_count" name="quick_chat_options[keep_around_count]" size="7" type="text" value="'.$quick_chat_options['keep_around_count'].'" />';
}


function setting_max_name_length_fn() {
    global $quick_chat_options;
    echo '<input id="quick_chat_max_name_length" name="quick_chat_options[max_name_length]" size="7" type="text" value="'.$quick_chat_options['max_name_length'].'" />';
}


function setting_guest_num_digits_fn() {
    global $quick_chat_options;
    echo '<input id="quick_chat_guest_num_digits" name="quick_chat_options[guest_num_digits]" size="7" type="text" value="'.$quick_chat_options['guest_num_digits'].'" />';
}

function setting_tld_blocklist_fn() {
    global $quick_chat_options;
    echo '<textarea id="quick_chat_tld_blocklist" name="quick_chat_options[tld_blocklist]" rows="5" cols="50" type="textarea">'.$quick_chat_options['tld_blocklist'].'</textarea>';
}

function setting_badwords_fn() {
    global $quick_chat_options;
    echo '<textarea id="quick_chat_bad_words" name="quick_chat_options[badwords_list]" rows="5" cols="50" type="textarea">'.$quick_chat_options['badwords_list'].'</textarea>';
}

function setting_replace_inside_bad_words_fn() {
    global $quick_chat_options;
    echo '<input id="quick_chat_replace_inside_bad_words" name="quick_chat_options[replace_inside_bad_words]" type="checkbox" value="1" ';
    if(isset($quick_chat_options['replace_inside_bad_words'])) echo 'checked="checked"';
    echo '/>';
}

function setting_hyperlinks_fn() {
    global $quick_chat_options;
    echo '<input id="quick_chat_hyperlinks" name="quick_chat_options[hyperlinks]" type="checkbox" value="1" ';
    if(isset($quick_chat_options['hyperlinks'])) echo 'checked="checked"';
    echo '/>';
}

function setting_keep_first_last_fn() {
    global $quick_chat_options;
    echo '<input id="quick_chat_keep_first_last" name="quick_chat_options[keep_first_last]" type="checkbox" value="1" ';
    if(isset($quick_chat_options['keep_first_last'])) echo 'checked="checked"';
    echo '/>';
}

function setting_hide_widget_if_embedded_fn() {
    global $quick_chat_options;
    echo '<input id="quick_chat_hide_widget_if_embedded" name="quick_chat_options[hide_widget_if_embedded]" type="checkbox" value="1" ';
    if(isset($quick_chat_options['hide_widget_if_embedded'])) echo 'checked="checked"';
    echo '/>';
}

function setting_hide_linkhome_fn() {
    global $quick_chat_options;
    echo '<input id="quick_chat_hide_linkhome" name="quick_chat_options[hide_linkhome]" type="checkbox" value="1" ';
    if(isset($quick_chat_options['hide_linkhome'])) echo 'checked="checked"';
    echo '/>';
}

function setting_allow_logged_in_choice_fn() {
    global $quick_chat_options;
    echo '<input id="quick_chat_allow_logged_in_choice" name="quick_chat_options[allow_logged_in_choice]" type="checkbox" value="1" ';
    if(isset($quick_chat_options['allow_logged_in_choice'])) echo 'checked="checked"';
    echo '/>';
}

function setting_only_logged_in_users_fn() {
    global $quick_chat_options;
    echo '<input id="quick_chat_only_logged_in_users" name="quick_chat_options[only_logged_in_users]" type="checkbox" value="1" ';
    if(isset($quick_chat_options['only_logged_in_users'])) echo 'checked="checked"';
    echo '/>';
}

function setting_allow_guests_choice_fn() {
    global $quick_chat_options;
    echo '<input id="quick_chat_allow_guests_choice" name="quick_chat_options[allow_guests_choice]" type="checkbox" value"1" ';
    if(isset($quick_chat_options['allow_guests_choice'])) echo 'checked="checked"';
    echo '/>';
}

function setting_message_sound_default_on_fn() {
    global $quick_chat_options;
    echo '<input id="quick_chat_message_sound_default_on" name="quick_chat_options[message_sound_default_on]" type="checkbox" value"1" ';
    if(isset($quick_chat_options['message_sound_default_on'])) echo 'checked="checked"';
    echo '/>';
}

function setting_disallow_logged_in_usernames_fn() {
    global $quick_chat_options;
    echo '<input id="quick_chat_disallow_logged_in_usernames" name="quick_chat_options[disallow_logged_in_usernames]" type="checkbox" value"1" ';
    if(isset($quick_chat_options['disallow_logged_in_usernames'])) echo 'checked="checked"';
    echo '/>';
}

function setting_disallow_usernames_list_fn() {
    global $quick_chat_options;
    echo '<textarea id="quick_chat_disallow_usernames_list" name="quick_chat_options[disallow_usernames_list]" rows="5" cols="50" type="textarea">'.$quick_chat_options['disallow_usernames_list'].'</textarea>';
}

function setting_ip_blocklist_fn() {
    global $quick_chat_options;
    echo '<textarea id="quick_chat_ip_blocklist" name="quick_chat_options[ip_blocklist]" rows="5" cols="50" type="textarea">'.$quick_chat_options['ip_blocklist'].'</textarea>';
}

// Display the admin options page
function options_page_fn() {
?>
    <div class="wrap">
        <div class="icon32" id="icon-options-general"><br></div>
        <h2>Quick Chat</h2>
        <form action="options.php" method="post">
        <?php settings_fields('quick_chat_options'); ?>
        <?php do_settings_sections(__FILE__); ?>
        <p class="submit">
                <input name="Submit" type="submit" class="button-primary" value="<?php esc_attr_e('Save Changes'); ?>" />
        </p>
        </form>
    </div>
<?php
}

// Validate user data for all of our input fields
function quick_chat_options_validate($input) {
    global $default_name;
    global $default_keep_around_count;
    global $default_guest_num_digits;
    
    // Validate default name
    if(trim($input['default_name']) == ''){
        $input['default_name'] =  $default_name;;
    } else{
        $input['default_name'] =  wp_filter_nohtml_kses(trim($input['default_name']));
    }
    
    // Validate keep around count
    if(!is_numeric($input['keep_around_count']) || $input['keep_around_count'] < 0){
        $input['keep_around_count'] =  $default_keep_around_count;
    }
    
    // Check our badwords field contains no HTML tags - if so strip them out
    $input['badwords_list'] =  wp_filter_nohtml_kses(trim($input['badwords_list']));
    
    // Check our badwords field contains no HTML tags - if so strip them out
    $input['tld_blocklist'] =  wp_filter_nohtml_kses(trim($input['tld_blocklist']));
    
    // Check our ip blocklist field contains no HTML tags - if so strip them out
    $input['ip_blocklist'] =  wp_filter_nohtml_kses(trim($input['ip_blocklist']));
    
    // Check our disallow logged in usernames field contains no HTML tags - if so strip them out
    $input['disallow_usernames_list'] =  wp_filter_nohtml_kses(trim($input['disallow_usernames_list']));
    
    if(!is_numeric($input['guest_num_digits'])){
        $input['guest_num_digits'] =  $default_guest_num_digits;
    } else if($input['guest_num_digits'] < 1){
        $input['guest_num_digits'] =  '1';
    } elseif($input['guest_num_digits'] > 10){
        $input['guest_num_digits'] =  '10';
    }    
    
    // Validate maximum length of chat user name
    if(!is_numeric($input['max_name_length']) || ($input['max_name_length'] < (strlen($input['default_name']) + $input['guest_num_digits']))){
        $input['max_name_length'] =  strlen($input['default_name']) + $input['guest_num_digits'];
    }    
    return $input; // return validated input      
}

function quick_chat_display_history_container($room) {
    ob_start();
    global $quick_chat_smile_array;
    global $quick_chat_options;
    global $quick_chat_url;
    global $wpdb;
    global $quick_chat_date_format;
    global $quick_chat_time_format;
    global $quick_chat_gmt_offset;
    global $quick_chat_last_timestamp;
    $quick_chat_messages_table_name = $wpdb->prefix . 'quick_chat';
    global $quick_chat_user_status;
    
    $stringAll = '';

    $history = $wpdb->get_results( 'SELECT * FROM '.$quick_chat_messages_table_name.' WHERE room = "'.$room.'" ORDER BY timestamp DESC' );
    $quick_chat_last_timestamp = time();
    
    if($history!=null){       
        /* Cleanup */
        $cleanupLimit = intval($quick_chat_options['keep_around_count'] * 1.2);
        if($quick_chat_options['keep_around_count'] != 0 && count($history) > $cleanupLimit){
            $last_id = $wpdb->get_var('SELECT max(id) FROM '.$quick_chat_messages_table_name);
            $toCleanLimit = intval($quick_chat_options['keep_around_count'] * 0.8);
            /* Delete last N */
            $wpdb->get_results( 'DELETE FROM '.$quick_chat_messages_table_name.' WHERE id < ( '.$last_id.' - '.$toCleanLimit.' )');
            /* Refresh history */
            $history = $wpdb->get_results( "SELECT * FROM $quick_chat_messages_table_name ORDER BY timestamp DESC" );
        }
        
        // Go through history messages and replace smile signs for smile images
        foreach($history as $v){
            foreach($quick_chat_smile_array as $smile_sign => $smile_img) $v->message = str_replace($smile_sign, '<img title="'.$smile_sign.'" src="'.$quick_chat_url.'img/smilies/'.$smile_img.'" />', $v->message);          

            $user_status_class = '';
            if($v->status == 0){
                $user_status_class = 'quick-chat-admin';
            } else if($v->status == 1){
                $user_status_class = 'quick-chat-loggedin';
            } else if($v->status == 2){
                $user_status_class = 'quick-chat-guest';
            }
            
            $string = ' <div class="quick-chat-history-message-alias-container '.$user_status_class.'"><div class="quick-chat-history-alias"><a href="" title="'.__('Reply to','quick-chat').' '.$v->alias.'">'.$v->alias.'</a></div>';
            $string .= '<div class="quick-chat-history-timestring">'.date_i18n($quick_chat_date_format.' - '.$quick_chat_time_format,$v->timestamp+($quick_chat_gmt_offset* 3600)).'</div>';
            if($quick_chat_user_status == 0){
                $string .= '<input class="quick-chat-to-delete-boxes" type="checkbox" name="quick-chat-to-delete[]" value="'.$v->id.'" />';
            }            
            $string .= '<div class="quick-chat-history-message">'.stripslashes($v->message).'</div></div>';

            $stringAll = $string.$stringAll;
        }
        echo $stringAll;
    }
    $content =  ob_get_contents();
    ob_end_clean();
    return $content;
}

function quick_chat_display_chat($height = 300, $room = 'default') {
    ob_start();
    global $quick_chat_smile_array;
    global $quick_chat_options;
    global $quick_chat_url;
    global $wpdb;
    global $quick_chat_date_format;
    global $quick_chat_time_format;
    global $quick_chat_gmt_offset;
    global $quick_chat_audio_enable;
    global $quick_chat_chat_data_array;
    global $quick_chat_user_ip;
    global $quick_chat_user_status;
    global $user_login;
    
    $quick_chat_messages_table_name = $wpdb->prefix . 'quick_chat';
    
    $quick_chat_chat_id = wp_generate_password(12,false,false);
    
    echo '<div class="quick-chat-container">';
    echo '<input type="hidden" name="quick-chat-chat-id" class="quick-chat-chat-id" value="'.$quick_chat_chat_id.'" />';
    echo '<div class="quick-chat-history-container" style="height: '.$height.'px;">';      
        echo quick_chat_display_history_container($room); 
    echo '</div>';
    
    $quick_chat_chat_data_array[$quick_chat_chat_id] = array('quick_chat_room_name' => $room, 'quick_chat_username_exists' => 0, 'quick_chat_username_blocked' => 0, 'quick_chat_username_check_wait' => 0);
    
    echo '  <div class="quick-chat-links">
                <div style="display: none;" class="quick-chat-sound-link">
                    <a ';
                    echo ($quick_chat_audio_enable) ? 'style="text-decoration: none;"' : 'style="text-decoration: line-through;"';
                    echo ' href="">'.__('Audio','quick-chat').'
                    </a>
                </div>';
                if ($quick_chat_user_status == 0){ 
                    echo '  <div class="quick-chat-select-all-link">
                                <a href="">'.__('Toggle all','quick-chat').'</a>
                            </div>
                            <div class="quick-chat-delete-link">
                                <a href="">'.__('Delete','quick-chat').'</a>
                            </div>';
                }
                echo '<div style="clear: both;"></div>
            </div>';
    
    $ip_blocked = 0;
    if(isset($quick_chat_options['ip_blocklist']) && ($quick_chat_options['ip_blocklist'] && $quick_chat_user_status != 0)){
        $blocked_ips = explode(',', $quick_chat_options['ip_blocklist']);
        foreach ($blocked_ips as $blocked_ip) {
            if(strcasecmp($quick_chat_user_ip, trim($blocked_ip)) == 0){
                $ip_blocked = 1;
                break;
            }
        }        
    }
    
    if($ip_blocked == 1){
        echo '<div class="quick-chat-bootom-notice">'.__('Your IP address is banned from chat.','quick-chat').'</div>';                        
    } else{
        get_currentuserinfo();        
        /* If only logged in allowed to use chat */
        if(isset($quick_chat_options['only_logged_in_users'])){
            /* Registered use it... */
            if ($quick_chat_user_status < 2){
                echo '<div class="quick-chat-alias-container">';
                echo '<input class="quick-chat-alias" type="text" autocomplete="off" value="';
                if(isset($quick_chat_options['allow_logged_in_choice']) || $quick_chat_user_status == 0){
                    if($quick_chat_user_status == 0 && isset($_COOKIE['quick_chat_admin_alias'])){
                        echo $_COOKIE['quick_chat_admin_alias'].'"';
                    }else if($quick_chat_user_status == 1 && isset($_COOKIE['quick_chat_loggedin_alias'])){
                        echo $_COOKIE['quick_chat_loggedin_alias'].'"';
                    }else{
                        echo $user_login.'"';
                    }
                } else{
                    echo $user_login.'" readonly="readonly"';
                }
            echo ' />';
            echo '<img class="quick-chat-username-taken" style="display: none;" src="'.$quick_chat_url.'img/smilies/warning.png" />';
            echo '<img class="quick-chat-username-check" style="display: none;" src="'.$quick_chat_url.'img/loader.gif" title="'.__('Please wait, user name check is in progress','quick-chat').'" />';
            echo '</div>';

            echo '<textarea class="quick-chat-message"></textarea>';

            echo '<div class="quick-chat-smilies-container">';
            foreach($quick_chat_smile_array as $smile_sign => $smile_img) echo '<img style="float: left; margin: 2px;" title="'.$smile_sign.'" src="'.$quick_chat_url.'img/smilies/'.$smile_img.'" />';
            echo '<div style="clear: both;"></div>';
            echo '</div>';

            /* Non logged in use it... */
            } else{
                echo '<div class="quick-chat-bootom-notice">'.__('You must login if you want to participate in chat.','quick-chat').'</div>';
            }        

        } else{
            echo '<div class="quick-chat-alias-container">';        
            if ($quick_chat_user_status < 2){
                echo '<input class="quick-chat-alias" type="text" autocomplete="off" value="';
                if(isset($quick_chat_options['allow_logged_in_choice']) || $quick_chat_user_status == 0){
                    if($quick_chat_user_status == 0 && isset($_COOKIE['quick_chat_admin_alias'])){
                        echo $_COOKIE['quick_chat_admin_alias'].'"';
                    }else if($quick_chat_user_status == 1 && isset($_COOKIE['quick_chat_loggedin_alias'])){
                        echo $_COOKIE['quick_chat_loggedin_alias'].'"';
                    }else{
                        echo $user_login.'"';
                    }
                } else{
                    echo $user_login.'" readonly="readonly"';
                }
            } else{
                echo '<input class="quick-chat-alias" type="text" autocomplete="off" maxlength="'.$quick_chat_options['max_name_length'].'" value="';
                $maxNumWithNumDigits = '';
                $numDigits = $quick_chat_options['guest_num_digits'];
                for($i=0; $i<$numDigits; $i++){
                    $maxNumWithNumDigits .= '9';
                }

                if(isset($quick_chat_options['allow_guests_choice'])){
                    if(isset($_COOKIE['quick_chat_guest_alias'])){
                        echo substr($_COOKIE['quick_chat_guest_alias'], 0, strlen($quick_chat_options['default_name']) + $quick_chat_options['guest_num_digits']).'"';
                    } else{
                        echo __($quick_chat_options['default_name'],'quick-chat').mt_rand(0, $maxNumWithNumDigits).'"';
                    }
                } else{
                    echo __($quick_chat_options['default_name'],'quick-chat').mt_rand(0, $maxNumWithNumDigits).'" readonly="readonly"';
                }
            }        
            echo ' />';
            echo '<img class="quick-chat-username-taken" style="display: none;" src="'.$quick_chat_url.'img/smilies/warning.png" />';
            echo '<img class="quick-chat-username-check" style="display: none;" src="'.$quick_chat_url.'img/loader.gif" title="'.__('Please wait, user name check is in progress','quick-chat').'" />';
            echo '</div>';

            echo '<textarea class="quick-chat-message"></textarea>';

            echo '<div class="quick-chat-smilies-container">';
            foreach($quick_chat_smile_array as $smile_sign => $smile_img) echo '<img style="float: left; margin: 2px;" title="'.$smile_sign.'" src="'.$quick_chat_url.'img/smilies/'.$smile_img.'" />';
            echo '<div style="clear: both;"></div>';
            echo '</div>';      
        }        
    }   

    if(!isset($quick_chat_options['hide_linkhome'])){
        echo '<a class="quick-chat-linkhome" href="http://www.techytalk.info/quick-chat" target="_blank">'.__('Powered by Quick Chat','quick-chat').'</a>';
    }
    echo '</div>';

    $content =  ob_get_contents();
    ob_end_clean();
    return $content;
}

// WP Widget class
class Quick_Chat extends WP_Widget {
    public $name = 'Quick Chat';
    /* Widget control settings. */
    public $control_options = array(
       'width' => 250,
       'height' => 300,
       'id_base' => 'quick-chat-widget');

    public function __construct() {
        $widget_options = array(
          'classname' => __CLASS__,
          'description' => __('Quick Chat is quick and elegant WordPress chat plugin that does not waste your bandwidth.','quick-chat'));

        parent::__construct($this->control_options['id_base'], $this->name, $widget_options);
    }
    
    // Widget admin code
    function form ($instance) {
        $defaults = array('title'=>'Quick Chat','widgetheight' => '250','room' => 'default');
        $instance = wp_parse_args( (array) $instance, $defaults );
        ?>
        <p>
        <label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title') ?>:</label>
        <input type="text" name="<?php echo $this->get_field_name('title') ?>" id="<?php echo $this->get_field_id('title') ?> " value="<?php echo $instance['title'] ?>" size="15">
        </p>
        
        <p>
        <label for="<?php echo $this->get_field_id('room'); ?>"><?php _e('Chat room') ?>:</label>
        <input type="text" name="<?php echo $this->get_field_name('room') ?>" id="<?php echo $this->get_field_id('room') ?> " value="<?php echo $instance['room'] ?>" size="15">
        </p>        

        <p>
        <label for="<?php echo $this->get_field_id('widgetheight'); ?>"><?php _e('Message container height:','quick-chat') ?></label>
        <input type="text" name="<?php echo $this->get_field_name('widgetheight') ?>" id="<?php echo $this->get_field_id('widgetheight') ?> " value="<?php echo $instance['widgetheight'] ?>" size="5">
        </p>
        <?php        
    }
    
    // Update widget code
    function update ($new_instance, $old_instance) {
        $instance = $old_instance;

        // Validate and update widgetheight
        if(is_numeric($new_instance['widgetheight'])){
            $instance['widgetheight'] = $new_instance['widgetheight'];
        }        
        $instance['title'] = $new_instance['title'];
        
        if($new_instance['room'] != ''){
            $instance['room'] = $new_instance['room'];
        }
        return $instance;
    }
    
    // Widget looks
    function widget ($args,$instance) {
        extract($args);
        $title = $instance['title'];
        $widgetheight = $instance['widgetheight'];
        $room = $instance['room'];
        global $quick_chat_is_embedded;
        global $quick_chat_options;
        global $wp_query;
        
        // We show widget if hide widget option isn't turned on or QC isn't embedded in current page
        if(!$quick_chat_is_embedded || !isset($quick_chat_options['hide_widget_if_embedded'])){
            // Print the widget for the sidebar
            echo $before_widget;
            echo $before_title.$title.$after_title;
            
            // We call widget printing function
            if($room == 'unique'){
                if(!is_home()){
                    $room = $wp_query->post->ID;
                } else{
                    $room = 'default';
                }                
            }else if($room == ''){
                $room = 'default';   
            }
            
            echo quick_chat_display_chat($widgetheight, $room);

            echo $after_widget;
        }
    }
}

function fn_load_widgets() {
  register_widget('Quick_Chat');
}
add_action('widgets_init', 'fn_load_widgets');

// Shortcode
function quick_chat_shortcode_handler( $atts, $content=null, $code="" ) {
    extract(shortcode_atts( array(	'height' => '300',
                                        'room' => 'default'),
                                        $atts ));
    global $quick_chat_is_embedded;
    
    $quick_chat_is_embedded = true;
    if($room == '') $room = 'default';
    $content = quick_chat_display_chat($height, $room);
    return $content;
}
add_shortcode( 'quick-chat', 'quick_chat_shortcode_handler' );

function quick_chat_uninstall() {
    global $wpdb;
    $quick_chat_messages_table_name = $wpdb->prefix . 'quick_chat';

    if(get_option('quick_chat_options')) delete_option('quick_chat_options');
    if(get_option('quick_chat_db_version')) delete_option('quick_chat_db_version');
    if(get_option('widget_quick-chat-widget')) delete_option('widget_quick-chat-widget');
    $query = $wpdb->query('DROP TABLE IF EXISTS '.$quick_chat_messages_table_name.';');
}
register_uninstall_hook(__FILE__, 'quick_chat_uninstall');
/* End of file quick-chat.php */